/*
 * Copyright (C) 2005-present, 58.com.  All rights reserved.
 * Use of this source code is governed by a BSD type license that can be
 * found in the LICENSE file.
 */

// https://myun-hw-s3.myun.tv/melj80jz/lnj4rd1z/1600137289418858342.m3u8_5.ts
// https://myun-hw-s3.myun.tv/melj80jz/lnj4rd1z/1600137289418858342.m3u8_234.ts
// https://myun-hw-s3.myun.tv/melj80jz/lnjmn9nm/1600737191445812640.m3u8
import 'dart:io';

import 'package:flutter_test/flutter_test.dart';
import 'package:http/http.dart' as http;
import 'package:path/path.dart';

void main() async {
  test('Download m3u8', () async {
    await download();
  });
  test('combine ts pieces', () {
    combine();
  });
  combine();
}

void combine() {
  var file = File('mubu/file.txt');
  var i = 1;
  var buffer = StringBuffer();
  while (i <= 239) {
    buffer.write('file 1600137289418858342.m3u8_$i.ts\n');
    i++;
  }
  file.writeAsStringSync(buffer.toString());
}

Future download() async {
  var index = 1;
  var client = HttpClient();
  var dir = 'mubu';
  while (index > 0) {
    var url =
        'https://myun-hw-s3.myun.tv/melj80jz/lnj4rd1z/1600137289418858342.m3u8_$index.ts';
    var response = await http.head(url);
    if (response.statusCode != 200) {
      break;
    }
    await Directory(dir).create();
    var fileName = '$dir/${basename(url)}';
    print(fileName);
    await client
        .getUrl(Uri.parse(url))
        .then((HttpClientRequest request) => request.close())
        .then((HttpClientResponse response) =>
            response.pipe(File(fileName).openWrite()))
        .catchError((e) {
      print(e);
    });
    index++;
  }
}
