/*
 * Copyright (C) 2005-present, 58.com.  All rights reserved.
 * Use of this source code is governed by a BSD type license that can be
 * found in the LICENSE file.
 */

// This is a basic Flutter widget test.
//
// To perform an interaction with a widget in your test, use the WidgetTester
// utility that Flutter provides. For example, you can send tap and scroll
// gestures. You can also use WidgetTester to find child widgets in the widget
// tree, read text, and verify that the values of widget properties are correct.

import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';

void main() {
  test('Match expression', () {
    var regexp = RegExp("#\\(.+\\)", multiLine: true);
    assert(regexp.hasMatch("#(Icons.thumb_up)"));
    assert(regexp.hasMatch("#(Icons.thumb_up)"));
    assert(regexp.hasMatch("#(Running on:\$_platformVersion)"));
    assert(!regexp.hasMatch(""));
    assert(!regexp.hasMatch("#()"));
    assert(!regexp.hasMatch("#("));
  });

  test('Match variable', () {
    var regexp = RegExp(r"\$\w+");

    var matches = regexp
        .allMatches("#(Running on:\$_platformVersion counting: \$_count)");
    assert(matches.length == 2);
    matches.forEach((element) {
      debugPrint(element.group(0));
    });
    assert(regexp.hasMatch("#(Running on:\$_platformVersion"));
    matches = regexp.allMatches("#(Running on:\$_platformVersion");
    assert(matches.length == 1);
    matches.forEach((element) {
      debugPrint(element.group(0));
    });
  });
}
